## TODO

- [x] Test types
- [x] Add binary
- [x] Subscribe on workers ready
- [x] Parallel (need prebuild? worker-farm?)
  - [x] Custom server runner
  - [x] Patch mocha runner with cluster
- [x] Allow customize hooks to non-storybook env
- [x] Defined default config + deep merge
- [x] Build correct `d.ts` files. For now, you should remove require types from `lib/creevey.js` after build.
- [x] Pass `config` to server initialization (use process.cwd())
- [x] Single fork for single browser thread
- [x] Mocha workers for server
- [x] Add test parser
- [x] Selenium keep alive
- [x] Allow start/stop tests
- [x] reconnect to selenium (sending keep-alive)
- [x] subscribe websocket api (status commands)
- [x] websocket api types
- [x] Generate static page in report dir
- [x] Save/Load results in/from report dir (js/json)
- [x] Save images report in multiple runs
- [x] Not graceful exit master process on error in workers
- [x] Add worker timeout and restart it
- [x] ~~Ignore elements from screenshot~~
- [x] Custom mocha reporter for worker
- [x] Allow to use Teamcity reporter
- [x] Add worker ready event
- [x] Support load test files from glob patterns
- [x] Better handle websocket messages
- [x] Allow define sets (test files, address, browsers)
  - [x] Filter tests by path in parser
  - [x] Merge common config with browser config
- [x] Web interface
  - [x] webpack build
  - [x] usage react-ui
  - [x] output tests tree
  - [x] allow start/stop
  - [x] comm with API by test id
  - [x] approve images
  - [x] Offile mode, load report data
  - [x] Output test error message
  - [x] output reported images
  - [x] better images view like github does
    - [x] SlideView
    - [x] BlendView
  - [x] switch images by hotkeys
  - [x] output test status (pending)
  - [x] update/recalc suite status
  - [x] use classnames (emotion)
  - [x] ApprovedRetry
  - [x] Fix incorrect output new images
  - [x] output skipped tests
  - [x] Output test error message
  - [x] Fit large images inside TestResultView
  - [x] Allow view fullscale images
  - [x] Invert expect/actual color
  - [x] Better output test error message
- [x] Test grep regexp dont work with parenthesis
- [x] Don't respect skip flag from report json
- [x] Browser resolution option
- [x] Fix TeamCity reporter `<unknown test name>`
- [x] Output images for Teamcity reporter
- [x] Setup viewport size
- [x] Color output in console
- [x] Server state sync
- [x] Config npmignore files
- [x] Status runner
- [x] Add Storybook for web ui components
- [x] ~~Composite images~~ (Split your story or test)
- [x] Restart selenium driver on timeout
- [x] Export decorator from creevey
- [ ] Firefox double click if clicks in different tests
- [ ] Reload IE page on start (don't handle storybook hotreload)
- [ ] Allow clean approved images
- [ ] Generate runtime tests based on stories
- [ ] Allow leave reason comment for skiped tests
- [ ] Update args readme (config, parser, ...)
- [ ] Simplify types re-export for lib usage
- [ ] Allow assert multiple images in one test
- [ ] Add cli arguments
  - [x] config
  - [x] parser
  - [x] ui
  - [x] reporter
  - [x] update
  - [x] ~~init~~
  - [ ] grep/kind/story
- [ ] Add storybook addon (add `All stories` story and `renderStory` global func)
  - [x] Update to Storybook@5.x
  - [x] Reset mouse position
  - [x] Support sotrybook 4.x-5.x
  - [ ] Write decorator that allow do some actions
- [ ] Transform to monorepo
  - [ ] `chai-image`
  - [ ] `creevey`
  - [ ] `creevey-ui`
  - [ ] `creevey-album` (storybook decorator and integration)
- [ ] Allow use custom API (wd/wdio/puppeter/etc)
- [ ] Improve UI performance on initial load
- [ ] Mocha worker `Possible EventEmitter memory leak detected. 11 error listeners added`
- [ ] Fix skip/unskip tests between run without delete report dir
- [ ] HotReload tests files without restart
- [ ] Handle error on mocha hooks
- [ ] Allow use standalone storybook
- [ ] Support mocha options for workers
- [ ] Add unit tests
- [ ] Allow define mocha hooks
- [ ] Add logger lib
- [ ] Programmic API
- [ ] Rewrite to use `worker_threads` instead of `cluster` to allow use shared memory
- [ ] vscode mocha explorer
  - [ ] codelens run not work (need full path)
  - [ ] tests run with default timeout even if it changed in config
  - [ ] cwd and require conflict each other
  - [ ] mocha opts and mocha bin is not prefect support
  - [ ] See for features to https://github.com/tsuyoshiwada/storybook-chrome-screenshot
- [ ] Use own runner instead of mocha

## Runtime function

```ts
// NOTE This need parallel tests
export function describeBrowser(browserName: string) {
  const testContext: string[] = [];

  chai.use(chaiImage(testContext));

  describe(browserName, function() {
    before(async function() {
      this.browser = await getBrowser(config, config.browsers[browserName]);
    });

    beforeEach(async function() {
      await switchStory.call(this, testContext);
    });

    require("path/to/test.ts");
  });
}
```
